#ifndef DOM_BINDINGNAMES_H_
#define DOM_BINDINGNAMES_H_

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioData = 335,
  AudioDecoder = 345,
  AudioDestinationNode = 358,
  AudioEncoder = 379,
  AudioListener = 392,
  AudioNode = 406,
  AudioParam = 416,
  AudioParamMap = 427,
  AudioProcessingEvent = 441,
  AudioScheduledSourceNode = 462,
  AudioTrack = 487,
  AudioTrackList = 498,
  AudioWorklet = 513,
  AudioWorkletGlobalScope = 526,
  AudioWorkletNode = 550,
  AudioWorkletProcessor = 567,
  AuthenticatorAssertionResponse = 589,
  AuthenticatorAttestationResponse = 620,
  AuthenticatorResponse = 653,
  BarProp = 675,
  BaseAudioContext = 683,
  BatteryManager = 700,
  BeforeUnloadEvent = 715,
  BiquadFilterNode = 733,
  Blob = 750,
  BlobEvent = 755,
  BroadcastChannel = 765,
  BrowsingContext = 782,
  BrowsingContextGroup = 798,
  ByteLengthQueuingStrategy = 819,
  CDATASection = 845,
  CSPViolationReportBody = 858,
  CSS = 881,
  CSS2Properties = 885,
  CSSAnimation = 900,
  CSSConditionRule = 913,
  CSSContainerRule = 930,
  CSSCounterStyleRule = 947,
  CSSCustomPropertyRegisteredEvent = 967,
  CSSFontFaceRule = 1000,
  CSSFontFeatureValuesRule = 1016,
  CSSFontPaletteValuesRule = 1041,
  CSSGroupingRule = 1066,
  CSSImportRule = 1082,
  CSSKeyframeRule = 1096,
  CSSKeyframesRule = 1112,
  CSSLayerBlockRule = 1129,
  CSSLayerStatementRule = 1147,
  CSSMarginRule = 1169,
  CSSMediaRule = 1183,
  CSSMozDocumentRule = 1196,
  CSSNamespaceRule = 1215,
  CSSNestedDeclarations = 1232,
  CSSPageDescriptors = 1254,
  CSSPageRule = 1273,
  CSSPositionTryDescriptors = 1285,
  CSSPositionTryRule = 1311,
  CSSPropertyRule = 1330,
  CSSPseudoElement = 1346,
  CSSRule = 1363,
  CSSRuleList = 1371,
  CSSScopeRule = 1383,
  CSSStartingStyleRule = 1396,
  CSSStyleDeclaration = 1417,
  CSSStyleRule = 1437,
  CSSStyleSheet = 1450,
  CSSSupportsRule = 1464,
  CSSTransition = 1480,
  Cache = 1494,
  CacheStorage = 1500,
  CallbackDebuggerNotification = 1513,
  CanonicalBrowsingContext = 1542,
  CanvasCaptureMediaStream = 1567,
  CanvasGradient = 1592,
  CanvasPattern = 1607,
  CanvasRenderingContext2D = 1621,
  CaretPosition = 1646,
  CaretStateChangedEvent = 1660,
  ChannelMergerNode = 1683,
  ChannelSplitterNode = 1701,
  ChannelWrapper = 1721,
  CharacterData = 1736,
  CheckerboardReportService = 1750,
  ChildProcessMessageManager = 1776,
  ChildSHistory = 1803,
  ChromeMessageBroadcaster = 1817,
  ChromeMessageSender = 1842,
  ChromeNodeList = 1862,
  ChromeUtils = 1877,
  ChromeWorker = 1889,
  Client = 1902,
  Clients = 1909,
  Clipboard = 1917,
  ClipboardEvent = 1927,
  ClipboardItem = 1942,
  ClonedErrorHolder = 1956,
  CloseEvent = 1974,
  CloseWatcher = 1985,
  CommandEvent = 1998,
  Comment = 2011,
  CompositionEvent = 2019,
  CompressionStream = 2036,
  ConsoleInstance = 2054,
  ConstantSourceNode = 2070,
  ContentFrameMessageManager = 2089,
  ContentProcessMessageManager = 2116,
  ContentVisibilityAutoStateChangeEvent = 2145,
  ConvolverNode = 2183,
  CookieChangeEvent = 2197,
  CookieStore = 2215,
  CookieStoreManager = 2227,
  CountQueuingStrategy = 2246,
  CreateOfferRequest = 2267,
  Credential = 2286,
  CredentialsContainer = 2297,
  Crypto = 2318,
  CryptoKey = 2325,
  CustomElementRegistry = 2335,
  CustomEvent = 2357,
  CustomStateSet = 2369,
  DOMException = 2384,
  DOMImplementation = 2397,
  DOMLocalization = 2415,
  DOMMatrix = 2431,
  DOMMatrixReadOnly = 2441,
  DOMParser = 2459,
  DOMPoint = 2469,
  DOMPointReadOnly = 2478,
  DOMQuad = 2495,
  DOMRect = 2503,
  DOMRectList = 2511,
  DOMRectReadOnly = 2523,
  DOMStringList = 2539,
  DOMStringMap = 2553,
  DOMTokenList = 2566,
  DataTransfer = 2579,
  DataTransferItem = 2592,
  DataTransferItemList = 2609,
  DebuggerNotification = 2630,
  DebuggerNotificationObserver = 2651,
  DecompressionStream = 2680,
  DedicatedWorkerGlobalScope = 2700,
  DelayNode = 2727,
  DeprecationReportBody = 2737,
  DeviceAcceleration = 2759,
  DeviceLightEvent = 2778,
  DeviceMotionEvent = 2795,
  DeviceOrientationEvent = 2813,
  DeviceRotationRate = 2836,
  Directory = 2855,
  Document = 2865,
  DocumentFragment = 2874,
  DocumentL10n = 2891,
  DocumentTimeline = 2904,
  DocumentType = 2921,
  DominatorTree = 2934,
  DragEvent = 2948,
  DynamicsCompressorNode = 2958,
  EXT_blend_minmax = 2981,
  EXT_color_buffer_float = 2998,
  EXT_color_buffer_half_float = 3021,
  EXT_depth_clamp = 3049,
  EXT_disjoint_timer_query = 3065,
  EXT_float_blend = 3090,
  EXT_frag_depth = 3106,
  EXT_sRGB = 3121,
  EXT_shader_texture_lod = 3130,
  EXT_texture_compression_bptc = 3153,
  EXT_texture_compression_rgtc = 3182,
  EXT_texture_filter_anisotropic = 3211,
  EXT_texture_norm16 = 3242,
  Element = 3261,
  ElementInternals = 3269,
  EncodedAudioChunk = 3286,
  EncodedVideoChunk = 3304,
  ErrorEvent = 3322,
  Event = 3333,
  EventCallbackDebuggerNotification = 3339,
  EventCounts = 3373,
  EventSource = 3385,
  EventTarget = 3397,
  Exception = 3409,
  ExtendableCookieChangeEvent = 3419,
  ExtendableEvent = 3447,
  ExtendableMessageEvent = 3463,
  ExtensionAlarms = 3486,
  ExtensionBrowser = 3502,
  ExtensionBrowserSettings = 3519,
  ExtensionBrowserSettingsColorManagement = 3544,
  ExtensionDns = 3584,
  ExtensionEventManager = 3597,
  ExtensionMockAPI = 3619,
  ExtensionPort = 3636,
  ExtensionProxy = 3650,
  ExtensionRuntime = 3665,
  ExtensionScripting = 3682,
  ExtensionSetting = 3701,
  ExtensionTest = 3718,
  External = 3732,
  FeaturePolicy = 3741,
  FeaturePolicyViolationReportBody = 3755,
  FetchEvent = 3788,
  FetchObserver = 3799,
  File = 3813,
  FileList = 3818,
  FileReader = 3827,
  FileReaderSync = 3838,
  FileSystem = 3853,
  FileSystemDirectoryEntry = 3864,
  FileSystemDirectoryHandle = 3889,
  FileSystemDirectoryHandle_AsyncIterator = 3915,
  FileSystemDirectoryIterator = 3955,
  FileSystemDirectoryReader = 3983,
  FileSystemEntry = 4009,
  FileSystemFileEntry = 4025,
  FileSystemFileHandle = 4045,
  FileSystemHandle = 4066,
  FileSystemSyncAccessHandle = 4083,
  FileSystemWritableFileStream = 4110,
  Flex = 4139,
  FlexItemValues = 4144,
  FlexLineValues = 4159,
  FluentBundle = 4174,
  FluentBundleAsyncIterator = 4187,
  FluentBundleIterator = 4213,
  FluentPattern = 4234,
  FluentResource = 4248,
  FocusEvent = 4263,
  FontFace = 4274,
  FontFaceSet = 4283,
  FontFaceSetIterator = 4295,
  FontFaceSetLoadEvent = 4315,
  FormData = 4336,
  FormData_Iterator = 4345,
  FormDataEvent = 4363,
  FragmentDirective = 4377,
  FrameCrashedEvent = 4395,
  FrameLoader = 4413,
  GPU = 4425,
  GPUAdapter = 4429,
  GPUAdapterInfo = 4440,
  GPUBindGroup = 4455,
  GPUBindGroupLayout = 4468,
  GPUBuffer = 4487,
  GPUBufferUsage = 4497,
  GPUCanvasContext = 4512,
  GPUColorWrite = 4529,
  GPUCommandBuffer = 4543,
  GPUCommandEncoder = 4560,
  GPUCompilationInfo = 4578,
  GPUCompilationMessage = 4597,
  GPUComputePassEncoder = 4619,
  GPUComputePipeline = 4641,
  GPUDevice = 4660,
  GPUDeviceLostInfo = 4670,
  GPUError = 4688,
  GPUExternalTexture = 4697,
  GPUInternalError = 4716,
  GPUMapMode = 4733,
  GPUOutOfMemoryError = 4744,
  GPUPipelineError = 4764,
  GPUPipelineLayout = 4781,
  GPUQuerySet = 4799,
  GPUQueue = 4811,
  GPURenderBundle = 4820,
  GPURenderBundleEncoder = 4836,
  GPURenderPassEncoder = 4859,
  GPURenderPipeline = 4880,
  GPUSampler = 4898,
  GPUShaderModule = 4909,
  GPUShaderStage = 4925,
  GPUSupportedFeatures = 4940,
  GPUSupportedLimits = 4961,
  GPUTexture = 4980,
  GPUTextureUsage = 4991,
  GPUTextureView = 5007,
  GPUUncapturedErrorEvent = 5022,
  GPUValidationError = 5046,
  GainNode = 5065,
  Gamepad = 5074,
  GamepadAxisMoveEvent = 5082,
  GamepadButton = 5103,
  GamepadButtonEvent = 5117,
  GamepadEvent = 5136,
  GamepadHapticActuator = 5149,
  GamepadLightIndicator = 5171,
  GamepadPose = 5193,
  GamepadServiceTest = 5205,
  GamepadTouch = 5224,
  Geolocation = 5237,
  GeolocationCoordinates = 5249,
  GeolocationPosition = 5272,
  GeolocationPositionError = 5292,
  GetUserMediaRequest = 5317,
  GleanBoolean = 5337,
  GleanCategory = 5350,
  GleanCounter = 5364,
  GleanCustomDistribution = 5377,
  GleanDatetime = 5401,
  GleanDenominator = 5415,
  GleanEvent = 5432,
  GleanImpl = 5443,
  GleanLabeled = 5453,
  GleanMemoryDistribution = 5466,
  GleanMetric = 5490,
  GleanNumerator = 5502,
  GleanObject = 5517,
  GleanPingsImpl = 5529,
  GleanQuantity = 5544,
  GleanRate = 5558,
  GleanString = 5568,
  GleanStringList = 5580,
  GleanText = 5596,
  GleanTimespan = 5606,
  GleanTimingDistribution = 5620,
  GleanUrl = 5644,
  GleanUuid = 5653,
  Grid = 5663,
  GridArea = 5668,
  GridDimension = 5677,
  GridLine = 5691,
  GridLines = 5700,
  GridTrack = 5710,
  GridTracks = 5720,
  HTMLAllCollection = 5731,
  HTMLAnchorElement = 5749,
  HTMLAreaElement = 5767,
  HTMLAudioElement = 5783,
  HTMLBRElement = 5800,
  HTMLBaseElement = 5814,
  HTMLBodyElement = 5830,
  HTMLButtonElement = 5846,
  HTMLCanvasElement = 5864,
  HTMLCollection = 5882,
  HTMLDListElement = 5897,
  HTMLDataElement = 5914,
  HTMLDataListElement = 5930,
  HTMLDetailsElement = 5950,
  HTMLDialogElement = 5969,
  HTMLDirectoryElement = 5987,
  HTMLDivElement = 6008,
  HTMLDocument = 6023,
  HTMLElement = 6036,
  HTMLEmbedElement = 6048,
  HTMLFieldSetElement = 6065,
  HTMLFontElement = 6085,
  HTMLFormControlsCollection = 6101,
  HTMLFormElement = 6128,
  HTMLFrameElement = 6144,
  HTMLFrameSetElement = 6161,
  HTMLHRElement = 6181,
  HTMLHeadElement = 6195,
  HTMLHeadingElement = 6211,
  HTMLHtmlElement = 6230,
  HTMLIFrameElement = 6246,
  HTMLImageElement = 6264,
  HTMLInputElement = 6281,
  HTMLLIElement = 6298,
  HTMLLabelElement = 6312,
  HTMLLegendElement = 6329,
  HTMLLinkElement = 6347,
  HTMLMapElement = 6363,
  HTMLMarqueeElement = 6378,
  HTMLMediaElement = 6397,
  HTMLMenuElement = 6414,
  HTMLMetaElement = 6430,
  HTMLMeterElement = 6446,
  HTMLModElement = 6463,
  HTMLOListElement = 6478,
  HTMLObjectElement = 6495,
  HTMLOptGroupElement = 6513,
  HTMLOptionElement = 6533,
  HTMLOptionsCollection = 6551,
  HTMLOutputElement = 6573,
  HTMLParagraphElement = 6591,
  HTMLParamElement = 6612,
  HTMLPictureElement = 6629,
  HTMLPreElement = 6648,
  HTMLProgressElement = 6663,
  HTMLQuoteElement = 6683,
  HTMLScriptElement = 6700,
  HTMLSelectElement = 6718,
  HTMLSlotElement = 6736,
  HTMLSourceElement = 6752,
  HTMLSpanElement = 6770,
  HTMLStyleElement = 6786,
  HTMLTableCaptionElement = 6803,
  HTMLTableCellElement = 6827,
  HTMLTableColElement = 6848,
  HTMLTableElement = 6868,
  HTMLTableRowElement = 6885,
  HTMLTableSectionElement = 6905,
  HTMLTemplateElement = 6929,
  HTMLTextAreaElement = 6949,
  HTMLTimeElement = 6969,
  HTMLTitleElement = 6985,
  HTMLTrackElement = 7002,
  HTMLUListElement = 7019,
  HTMLUnknownElement = 7036,
  HTMLVideoElement = 7055,
  HashChangeEvent = 7072,
  Headers = 7088,
  Headers_Iterator = 7096,
  HeapSnapshot = 7113,
  Highlight = 7126,
  HighlightRegistry = 7136,
  History = 7154,
  IDBCursor = 7162,
  IDBCursorWithValue = 7172,
  IDBDatabase = 7191,
  IDBFactory = 7203,
  IDBIndex = 7214,
  IDBKeyRange = 7223,
  IDBObjectStore = 7235,
  IDBOpenDBRequest = 7250,
  IDBRequest = 7267,
  IDBTransaction = 7278,
  IDBVersionChangeEvent = 7293,
  IIRFilterNode = 7315,
  IOUtils = 7329,
  IdentityCredential = 7337,
  IdleDeadline = 7356,
  Image = 7369,
  ImageBitmap = 7375,
  ImageBitmapRenderingContext = 7387,
  ImageCapture = 7415,
  ImageCaptureError = 7428,
  ImageCaptureErrorEvent = 7446,
  ImageData = 7469,
  ImageDecoder = 7479,
  ImageDocument = 7492,
  ImageTrack = 7506,
  ImageTrackList = 7517,
  InferenceSession = 7532,
  InputEvent = 7549,
  InspectorCSSParser = 7560,
  InspectorFontFace = 7579,
  InspectorUtils = 7597,
  InstallTriggerImpl = 7612,
  IntersectionObserver = 7631,
  IntersectionObserverEntry = 7652,
  IntlUtils = 7678,
  JSProcessActorChild = 7688,
  JSProcessActorParent = 7708,
  JSWindowActorChild = 7729,
  JSWindowActorParent = 7748,
  KeyEvent = 7768,
  KeyboardEvent = 7777,
  KeyframeEffect = 7791,
  L10nFileSource = 7806,
  L10nOverlays = 7821,
  L10nRegistry = 7834,
  LargestContentfulPaint = 7847,
  LegacyMozTCPSocket = 7870,
  Localization = 7889,
  Location = 7902,
  Lock = 7911,
  LockManager = 7916,
  MIDIAccess = 7928,
  MIDIConnectionEvent = 7939,
  MIDIInput = 7959,
  MIDIInputMap = 7969,
  MIDIMessageEvent = 7982,
  MIDIOutput = 7999,
  MIDIOutputMap = 8010,
  MIDIPort = 8024,
  MLS = 8033,
  MLSGroupView = 8037,
  MOZ_debug = 8050,
  MatchGlob = 8060,
  MatchPattern = 8070,
  MatchPatternSet = 8083,
  MathMLElement = 8099,
  MediaCapabilities = 8113,
  MediaControlService = 8131,
  MediaController = 8151,
  MediaDeviceInfo = 8167,
  MediaDevices = 8183,
  MediaElementAudioSourceNode = 8196,
  MediaEncryptedEvent = 8224,
  MediaError = 8244,
  MediaKeyError = 8255,
  MediaKeyMessageEvent = 8269,
  MediaKeySession = 8290,
  MediaKeyStatusMap = 8306,
  MediaKeyStatusMap_Iterator = 8324,
  MediaKeySystemAccess = 8351,
  MediaKeys = 8372,
  MediaList = 8382,
  MediaMetadata = 8392,
  MediaQueryList = 8406,
  MediaQueryListEvent = 8421,
  MediaRecorder = 8441,
  MediaRecorderErrorEvent = 8455,
  MediaSession = 8479,
  MediaSource = 8492,
  MediaStream = 8504,
  MediaStreamAudioDestinationNode = 8516,
  MediaStreamAudioSourceNode = 8548,
  MediaStreamError = 8575,
  MediaStreamEvent = 8592,
  MediaStreamTrack = 8609,
  MediaStreamTrackAudioSourceNode = 8626,
  MediaStreamTrackEvent = 8658,
  MerchantValidationEvent = 8680,
  MessageBroadcaster = 8704,
  MessageChannel = 8723,
  MessageEvent = 8738,
  MessageListenerManager = 8751,
  MessagePort = 8774,
  MessageSender = 8786,
  MimeType = 8800,
  MimeTypeArray = 8809,
  MouseEvent = 8823,
  MouseScrollEvent = 8834,
  MozCanvasPrintState = 8851,
  MozDocumentMatcher = 8871,
  MozDocumentObserver = 8890,
  MozQueryInterface = 8910,
  MozSharedMap = 8928,
  MozSharedMap_Iterator = 8941,
  MozSharedMapChangeEvent = 8963,
  MozStorageAsyncStatementParams = 8987,
  MozStorageStatementParams = 9018,
  MozStorageStatementRow = 9044,
  MozWritableSharedMap = 9067,
  MutationEvent = 9088,
  MutationObserver = 9102,
  MutationRecord = 9119,
  NamedNodeMap = 9134,
  NavigateEvent = 9147,
  Navigation = 9161,
  NavigationActivation = 9172,
  NavigationCurrentEntryChangeEvent = 9193,
  NavigationDestination = 9227,
  NavigationHistoryEntry = 9249,
  NavigationPreloadManager = 9272,
  NavigationTransition = 9297,
  Navigator = 9318,
  NavigatorLogin = 9328,
  NetworkInformation = 9343,
  Node = 9362,
  NodeFilter = 9367,
  NodeIterator = 9378,
  NodeList = 9391,
  Notification = 9400,
  NotificationEvent = 9413,
  NotifyPaintEvent = 9431,
  OES_draw_buffers_indexed = 9448,
  OES_element_index_uint = 9473,
  OES_fbo_render_mipmap = 9496,
  OES_standard_derivatives = 9518,
  OES_texture_float = 9543,
  OES_texture_float_linear = 9561,
  OES_texture_half_float = 9586,
  OES_texture_half_float_linear = 9609,
  OES_vertex_array_object = 9639,
  OVR_multiview2 = 9663,
  OfflineAudioCompletionEvent = 9678,
  OfflineAudioContext = 9706,
  OffscreenCanvas = 9726,
  OffscreenCanvasRenderingContext2D = 9742,
  OnlyForUseInConstructor = 9776,
  Option = 9800,
  OscillatorNode = 9807,
  PageTransitionEvent = 9822,
  PaintRequest = 9842,
  PaintRequestList = 9855,
  PaintWorkletGlobalScope = 9872,
  PannerNode = 9896,
  ParentProcessMessageManager = 9907,
  Path2D = 9935,
  PathUtils = 9942,
  PaymentAddress = 9952,
  PaymentMethodChangeEvent = 9967,
  PaymentRequest = 9992,
  PaymentRequestUpdateEvent = 10007,
  PaymentResponse = 10033,
  PeerConnectionImpl = 10049,
  PeerConnectionObserver = 10068,
  Performance = 10091,
  PerformanceEntry = 10103,
  PerformanceEntryEvent = 10120,
  PerformanceEventTiming = 10142,
  PerformanceMark = 10165,
  PerformanceMeasure = 10181,
  PerformanceNavigation = 10200,
  PerformanceNavigationTiming = 10222,
  PerformanceObserver = 10250,
  PerformanceObserverEntryList = 10270,
  PerformancePaintTiming = 10299,
  PerformanceResourceTiming = 10322,
  PerformanceServerTiming = 10348,
  PerformanceTiming = 10372,
  PeriodicWave = 10390,
  PermissionStatus = 10403,
  Permissions = 10420,
  PlacesBookmark = 10432,
  PlacesBookmarkAddition = 10447,
  PlacesBookmarkChanged = 10470,
  PlacesBookmarkGuid = 10492,
  PlacesBookmarkKeyword = 10511,
  PlacesBookmarkMoved = 10533,
  PlacesBookmarkRemoved = 10553,
  PlacesBookmarkTags = 10575,
  PlacesBookmarkTime = 10594,
  PlacesBookmarkTitle = 10613,
  PlacesBookmarkUrl = 10633,
  PlacesEvent = 10651,
  PlacesEventCounts = 10663,
  PlacesFavicon = 10681,
  PlacesHistoryCleared = 10695,
  PlacesObservers = 10716,
  PlacesPurgeCaches = 10732,
  PlacesRanking = 10750,
  PlacesVisit = 10764,
  PlacesVisitRemoved = 10776,
  PlacesVisitTitle = 10795,
  PlacesWeakCallbackWrapper = 10812,
  Plugin = 10838,
  PluginArray = 10845,
  PluginCrashedEvent = 10857,
  PointerEvent = 10876,
  PopStateEvent = 10889,
  PopupBlockedEvent = 10903,
  PopupPositionedEvent = 10921,
  PositionStateEvent = 10942,
  PrecompiledScript = 10961,
  PrivateAttribution = 10979,
  ProcessMessageManager = 10998,
  ProcessingInstruction = 11020,
  ProgressEvent = 11042,
  PromiseDebugging = 11056,
  PromiseNativeHandler = 11073,
  PromiseRejectionEvent = 11094,
  PublicKeyCredential = 11116,
  PushEvent = 11136,
  PushManager = 11146,
  PushManagerImpl = 11158,
  PushMessageData = 11174,
  PushSubscription = 11190,
  PushSubscriptionChangeEvent = 11207,
  PushSubscriptionOptions = 11235,
  RTCCertificate = 11259,
  RTCDTMFSender = 11274,
  RTCDTMFToneChangeEvent = 11288,
  RTCDataChannel = 11311,
  RTCDataChannelEvent = 11326,
  RTCDtlsTransport = 11346,
  RTCEncodedAudioFrame = 11363,
  RTCEncodedVideoFrame = 11384,
  RTCIceCandidate = 11405,
  RTCIceTransport = 11421,
  RTCIdentityProviderRegistrar = 11437,
  RTCPeerConnection = 11466,
  RTCPeerConnectionIceEvent = 11484,
  RTCPeerConnectionStatic = 11510,
  RTCRtpReceiver = 11534,
  RTCRtpScriptTransform = 11549,
  RTCRtpScriptTransformer = 11571,
  RTCRtpSender = 11595,
  RTCRtpTransceiver = 11608,
  RTCSctpTransport = 11626,
  RTCSessionDescription = 11643,
  RTCStatsReport = 11665,
  RTCTrackEvent = 11680,
  RTCTransformEvent = 11694,
  RadioNodeList = 11712,
  Range = 11726,
  ReadableByteStreamController = 11732,
  ReadableStream = 11761,
  ReadableStream_AsyncIterator = 11776,
  ReadableStreamBYOBReader = 11805,
  ReadableStreamBYOBRequest = 11830,
  ReadableStreamDefaultController = 11856,
  ReadableStreamDefaultReader = 11888,
  Report = 11916,
  ReportBody = 11923,
  ReportingObserver = 11934,
  Request = 11952,
  ResizeObserver = 11960,
  ResizeObserverEntry = 11975,
  ResizeObserverSize = 11995,
  Response = 12014,
  SVGAElement = 12023,
  SVGAngle = 12035,
  SVGAnimateElement = 12044,
  SVGAnimateMotionElement = 12062,
  SVGAnimateTransformElement = 12086,
  SVGAnimatedAngle = 12113,
  SVGAnimatedBoolean = 12130,
  SVGAnimatedEnumeration = 12149,
  SVGAnimatedInteger = 12172,
  SVGAnimatedLength = 12191,
  SVGAnimatedLengthList = 12209,
  SVGAnimatedNumber = 12231,
  SVGAnimatedNumberList = 12249,
  SVGAnimatedPreserveAspectRatio = 12271,
  SVGAnimatedRect = 12302,
  SVGAnimatedString = 12318,
  SVGAnimatedTransformList = 12336,
  SVGAnimationElement = 12361,
  SVGCircleElement = 12381,
  SVGClipPathElement = 12398,
  SVGComponentTransferFunctionElement = 12417,
  SVGDefsElement = 12453,
  SVGDescElement = 12468,
  SVGElement = 12483,
  SVGEllipseElement = 12494,
  SVGFEBlendElement = 12512,
  SVGFEColorMatrixElement = 12530,
  SVGFEComponentTransferElement = 12554,
  SVGFECompositeElement = 12584,
  SVGFEConvolveMatrixElement = 12606,
  SVGFEDiffuseLightingElement = 12633,
  SVGFEDisplacementMapElement = 12661,
  SVGFEDistantLightElement = 12689,
  SVGFEDropShadowElement = 12714,
  SVGFEFloodElement = 12737,
  SVGFEFuncAElement = 12755,
  SVGFEFuncBElement = 12773,
  SVGFEFuncGElement = 12791,
  SVGFEFuncRElement = 12809,
  SVGFEGaussianBlurElement = 12827,
  SVGFEImageElement = 12852,
  SVGFEMergeElement = 12870,
  SVGFEMergeNodeElement = 12888,
  SVGFEMorphologyElement = 12910,
  SVGFEOffsetElement = 12933,
  SVGFEPointLightElement = 12952,
  SVGFESpecularLightingElement = 12975,
  SVGFESpotLightElement = 13004,
  SVGFETileElement = 13026,
  SVGFETurbulenceElement = 13043,
  SVGFilterElement = 13066,
  SVGForeignObjectElement = 13083,
  SVGGElement = 13107,
  SVGGeometryElement = 13119,
  SVGGradientElement = 13138,
  SVGGraphicsElement = 13157,
  SVGImageElement = 13176,
  SVGLength = 13192,
  SVGLengthList = 13202,
  SVGLineElement = 13216,
  SVGLinearGradientElement = 13231,
  SVGMPathElement = 13256,
  SVGMarkerElement = 13272,
  SVGMaskElement = 13289,
  SVGMatrix = 13304,
  SVGMetadataElement = 13314,
  SVGNumber = 13333,
  SVGNumberList = 13343,
  SVGPathElement = 13357,
  SVGPathSegment = 13372,
  SVGPatternElement = 13387,
  SVGPoint = 13405,
  SVGPointList = 13414,
  SVGPolygonElement = 13427,
  SVGPolylineElement = 13445,
  SVGPreserveAspectRatio = 13464,
  SVGRadialGradientElement = 13487,
  SVGRect = 13512,
  SVGRectElement = 13520,
  SVGSVGElement = 13535,
  SVGScriptElement = 13549,
  SVGSetElement = 13566,
  SVGStopElement = 13580,
  SVGStringList = 13595,
  SVGStyleElement = 13609,
  SVGSwitchElement = 13625,
  SVGSymbolElement = 13642,
  SVGTSpanElement = 13659,
  SVGTextContentElement = 13675,
  SVGTextElement = 13697,
  SVGTextPathElement = 13712,
  SVGTextPositioningElement = 13731,
  SVGTitleElement = 13757,
  SVGTransform = 13773,
  SVGTransformList = 13786,
  SVGUnitTypes = 13803,
  SVGUseElement = 13816,
  SVGViewElement = 13830,
  Sanitizer = 13845,
  Scheduler = 13855,
  Screen = 13865,
  ScreenLuminance = 13872,
  ScreenOrientation = 13888,
  ScriptProcessorNode = 13906,
  ScrollAreaEvent = 13926,
  SecurityPolicyViolationEvent = 13942,
  Selection = 13971,
  ServiceWorker = 13981,
  ServiceWorkerContainer = 13995,
  ServiceWorkerGlobalScope = 14018,
  ServiceWorkerRegistration = 14043,
  SessionStoreFormData = 14069,
  SessionStoreScrollData = 14090,
  SessionStoreUtils = 14113,
  ShadowRealmGlobalScope = 14131,
  ShadowRoot = 14154,
  SharedWorker = 14165,
  SharedWorkerGlobalScope = 14178,
  SimpleGestureEvent = 14202,
  SourceBuffer = 14221,
  SourceBufferList = 14234,
  SpeechGrammar = 14251,
  SpeechGrammarList = 14265,
  SpeechRecognition = 14283,
  SpeechRecognitionAlternative = 14301,
  SpeechRecognitionError = 14330,
  SpeechRecognitionEvent = 14353,
  SpeechRecognitionResult = 14376,
  SpeechRecognitionResultList = 14400,
  SpeechSynthesis = 14428,
  SpeechSynthesisErrorEvent = 14444,
  SpeechSynthesisEvent = 14470,
  SpeechSynthesisUtterance = 14491,
  SpeechSynthesisVoice = 14516,
  StaticRange = 14537,
  StereoPannerNode = 14549,
  Storage = 14566,
  StorageEvent = 14574,
  StorageManager = 14587,
  StreamFilter = 14602,
  StreamFilterDataEvent = 14615,
  StructuredCloneHolder = 14637,
  StructuredCloneTester = 14659,
  StyleSheet = 14681,
  StyleSheetApplicableStateChangeEvent = 14692,
  StyleSheetList = 14729,
  StyleSheetRemovedEvent = 14744,
  SubmitEvent = 14767,
  SubtleCrypto = 14779,
  SyncMessageSender = 14792,
  SyncReadFile = 14810,
  TCPServerSocket = 14823,
  TCPServerSocketEvent = 14839,
  TCPSocket = 14860,
  TCPSocketErrorEvent = 14870,
  TCPSocketEvent = 14890,
  TaskController = 14905,
  TaskPriorityChangeEvent = 14920,
  TaskSignal = 14944,
  Tensor = 14955,
  TestAttributesOnTypes = 14962,
  TestCEReactionsInterface = 14984,
  TestCImplementedInterface = 15009,
  TestCImplementedInterface2 = 15035,
  TestCallbackDictUnionOverload = 15062,
  TestChildInterface = 15092,
  TestConstructorForFuncInterface = 15111,
  TestConstructorForPrefInterface = 15143,
  TestConstructorForSCInterface = 15175,
  TestCppKeywordNamedMethodsInterface = 15205,
  TestDeprecatedInterface = 15241,
  TestExampleInterface = 15265,
  TestExampleProxyInterface = 15286,
  TestExampleThrowingConstructorInterface = 15312,
  TestExampleWorkerInterface = 15352,
  TestFuncConstructorForDifferentFuncInterface = 15379,
  TestFuncConstructorForInterface = 15424,
  TestHTMLConstructorInterface = 15456,
  TestIndexedAndNamedGetterAndSetterInterface = 15485,
  TestIndexedAndNamedGetterInterface = 15529,
  TestIndexedAndNamedSetterInterface = 15564,
  TestIndexedGetterAndSetterAndNamedGetterInterface = 15599,
  TestIndexedGetterInterface = 15649,
  TestIndexedSetterInterface = 15676,
  TestInterface = 15703,
  TestInterfaceWithPromiseConstructorArg = 15717,
  TestJSImplInterface = 15756,
  TestJSImplInterface2 = 15776,
  TestJSImplInterface3 = 15797,
  TestJSImplInterface4 = 15818,
  TestJSImplInterface5 = 15839,
  TestJSImplInterface6 = 15860,
  TestJSImplNoInterfaceObject = 15881,
  TestLegacyFactoryFunctionInterface = 15909,
  TestLegacyFactoryFunctionInterface2 = 15944,
  TestNamedDeleterInterface = 15980,
  TestNamedDeleterWithRetvalInterface = 16006,
  TestNamedGetterInterface = 16042,
  TestNamedSetterInterface = 16067,
  TestNamespace = 16092,
  TestNonWrapperCacheInterface = 16106,
  TestParentInterface = 16135,
  TestPrefChromeOnlySCFuncConstructorForInterface = 16155,
  TestPrefConstructorForDifferentPrefInterface = 16203,
  TestPrefConstructorForInterface = 16248,
  TestProtoObjectHackedNamespace = 16280,
  TestRenamedInterface = 16311,
  TestRenamedNamespace = 16332,
  TestSCConstructorForInterface = 16353,
  TestSecureContextInterface = 16383,
  TestThrowingConstructorInterface = 16410,
  TestUtils = 16443,
  TestWorkerExposedInterface = 16453,
  TestingDeprecatedInterface = 16480,
  Text = 16507,
  TextClause = 16512,
  TextDecoder = 16523,
  TextDecoderStream = 16535,
  TextEncoder = 16553,
  TextEncoderStream = 16565,
  TextEvent = 16583,
  TextMetrics = 16593,
  TextTrack = 16605,
  TextTrackCue = 16615,
  TextTrackCueList = 16628,
  TextTrackList = 16645,
  TimeEvent = 16659,
  TimeRanges = 16669,
  ToggleEvent = 16680,
  Touch = 16692,
  TouchEvent = 16698,
  TouchList = 16709,
  TrackEvent = 16719,
  TransformStream = 16730,
  TransformStreamDefaultController = 16746,
  TransitionEvent = 16779,
  TreeColumn = 16795,
  TreeColumns = 16806,
  TreeContentView = 16818,
  TreeWalker = 16834,
  TrustedHTML = 16845,
  TrustedScript = 16857,
  TrustedScriptURL = 16871,
  TrustedTypePolicy = 16888,
  TrustedTypePolicyFactory = 16906,
  UDPMessageEvent = 16931,
  UDPSocket = 16947,
  UIEvent = 16957,
  URL = 16965,
  URLSearchParams = 16969,
  URLSearchParams_Iterator = 16985,
  UniFFIPointer = 17010,
  UniFFIScaffolding = 17024,
  UserActivation = 17042,
  UserInteraction = 17057,
  UserProximityEvent = 17073,
  VRDisplay = 17092,
  VRDisplayCapabilities = 17102,
  VRDisplayEvent = 17124,
  VREyeParameters = 17139,
  VRFieldOfView = 17155,
  VRFrameData = 17169,
  VRMockController = 17181,
  VRMockDisplay = 17198,
  VRPose = 17212,
  VRServiceTest = 17219,
  VRStageParameters = 17233,
  VTTCue = 17251,
  VTTRegion = 17258,
  ValidityState = 17268,
  VideoColorSpace = 17282,
  VideoDecoder = 17298,
  VideoEncoder = 17311,
  VideoFrame = 17324,
  VideoPlaybackQuality = 17335,
  VideoTrack = 17356,
  VideoTrackList = 17367,
  ViewTransition = 17382,
  VisualViewport = 17397,
  WEBGL_color_buffer_float = 17412,
  WEBGL_compressed_texture_astc = 17437,
  WEBGL_compressed_texture_etc = 17467,
  WEBGL_compressed_texture_etc1 = 17496,
  WEBGL_compressed_texture_pvrtc = 17526,
  WEBGL_compressed_texture_s3tc = 17557,
  WEBGL_compressed_texture_s3tc_srgb = 17587,
  WEBGL_debug_renderer_info = 17622,
  WEBGL_debug_shaders = 17648,
  WEBGL_depth_texture = 17668,
  WEBGL_draw_buffers = 17688,
  WEBGL_explicit_present = 17707,
  WEBGL_lose_context = 17730,
  WEBGL_provoking_vertex = 17749,
  WGSLLanguageFeatures = 17772,
  WakeLock = 17793,
  WakeLockSentinel = 17802,
  WaveShaperNode = 17819,
  WebExtensionContentScript = 17834,
  WebExtensionPolicy = 17860,
  WebGL2RenderingContext = 17879,
  WebGLActiveInfo = 17902,
  WebGLBuffer = 17918,
  WebGLContextEvent = 17930,
  WebGLFramebuffer = 17948,
  WebGLProgram = 17965,
  WebGLQuery = 17978,
  WebGLRenderbuffer = 17989,
  WebGLRenderingContext = 18007,
  WebGLSampler = 18029,
  WebGLShader = 18042,
  WebGLShaderPrecisionFormat = 18054,
  WebGLSync = 18081,
  WebGLTexture = 18091,
  WebGLTransformFeedback = 18104,
  WebGLUniformLocation = 18127,
  WebGLVertexArrayObject = 18148,
  WebKitCSSMatrix = 18171,
  WebSocket = 18187,
  WebTransport = 18197,
  WebTransportBidirectionalStream = 18210,
  WebTransportDatagramDuplexStream = 18242,
  WebTransportError = 18275,
  WebTransportReceiveStream = 18293,
  WebTransportSendStream = 18319,
  WebrtcGlobalInformation = 18342,
  WheelEvent = 18366,
  Window = 18377,
  WindowClient = 18384,
  WindowContext = 18397,
  WindowGlobalChild = 18411,
  WindowGlobalParent = 18429,
  WindowRoot = 18448,
  Worker = 18459,
  WorkerDebuggerGlobalScope = 18466,
  WorkerGlobalScope = 18492,
  WorkerLocation = 18510,
  WorkerNavigator = 18525,
  WorkerTestUtils = 18541,
  Worklet = 18557,
  WorkletGlobalScope = 18565,
  WritableStream = 18584,
  WritableStreamDefaultController = 18599,
  WritableStreamDefaultWriter = 18631,
  XMLDocument = 18659,
  XMLHttpRequest = 18671,
  XMLHttpRequestEventTarget = 18686,
  XMLHttpRequestUpload = 18712,
  XMLSerializer = 18733,
  XPathEvaluator = 18747,
  XPathExpression = 18762,
  XPathResult = 18778,
  XRBoundedReferenceSpace = 18790,
  XRFrame = 18814,
  XRInputSource = 18822,
  XRInputSourceArray = 18836,
  XRInputSourceEvent = 18855,
  XRInputSourcesChangeEvent = 18874,
  XRPose = 18900,
  XRReferenceSpace = 18907,
  XRReferenceSpaceEvent = 18924,
  XRRenderState = 18946,
  XRRigidTransform = 18960,
  XRSession = 18977,
  XRSessionEvent = 18987,
  XRSpace = 19002,
  XRSystem = 19010,
  XRView = 19019,
  XRViewerPose = 19026,
  XRViewport = 19039,
  XRWebGLLayer = 19050,
  XSLTProcessor = 19063,
  XULCommandEvent = 19077,
  XULElement = 19093,
  XULFrameElement = 19104,
  XULMenuElement = 19120,
  XULPopupElement = 19135,
  XULResizerElement = 19151,
  XULTextElement = 19169,
  XULTreeElement = 19184,
  console = 19199,
  webkitSpeechGrammar = 19207,
  webkitSpeechGrammarList = 19227,
  webkitSpeechRecognition = 19251,
  webkitURL = 19275,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // DOM_BINDINGNAMES_H_
