// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_GleanDomMetrics_h
#define mozilla_GleanDomMetrics_h

#include "mozilla/glean/bindings/MetricTypes.h"

namespace mozilla::glean {

namespace glam_experiment {
  /**
   * generated from glam_experiment.largest_contentful_paint
   * Duplicate of: `perf.largest_contentful_paint`
   * Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint(299);

  /**
   * generated from glam_experiment.protect_time
   * Duplicate of: `javascript_pageload.protect_time`
   * Intended for the purpose of testing client side sampling of data. This metric is disabled by default and will be enabled only for the purpose of the experiment. See Bug 1947604 for more information.
   */
  constexpr impl::TimingDistributionMetric protect_time(300);
}

namespace security {
  /**
   * generated from security.fission_principals
   */
  struct FissionPrincipalsExtra {
    mozilla::Maybe<nsCString> principaltype;
    mozilla::Maybe<nsCString> scheme;
    mozilla::Maybe<nsCString> value;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (principaltype) {
        extraKeys.AppendElement()->AssignASCII("principalType");
        extraValues.EmplaceBack(principaltype.value());
      }
      if (scheme) {
        extraKeys.AppendElement()->AssignASCII("scheme");
        extraValues.EmplaceBack(scheme.value());
      }
      if (value) {
        extraKeys.AppendElement()->AssignASCII("value");
        extraValues.EmplaceBack(value.value());
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * When running with Fission, we received an unexpected principal from the content process. Expected values for this telemetry event are the method names in ContentParent that received the unexpected principal. This event was generated to correspond to the Legacy Telemetry event security.fissionPrincipals#contentParent.
   */
  constexpr impl::EventMetric<FissionPrincipalsExtra> fission_principals(436);

  /**
   * generated from security.shadowed_html_document_property_access
   */
  struct ShadowedHtmlDocumentPropertyAccessExtra {
    mozilla::Maybe<nsCString> name;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (name) {
        extraKeys.AppendElement()->AssignASCII("name");
        extraValues.EmplaceBack(name.value());
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * When accessing a property on the HTMLDocument like (document.currentScript), if that property was shadowed/"clobbered" (e.g. using <img name=currentScript>), the name of the shadowed built-in property is collected.
   */
  constexpr impl::EventMetric<ShadowedHtmlDocumentPropertyAccessExtra> shadowed_html_document_property_access(437);
}

namespace performance_page {
  /**
   * generated from performance.page.non_blank_paint
   * The time between navigationStart and the first non-blank paint of a foreground root content document, in milliseconds. This only records documents that were in an active docshell throughout the whole time between navigation start and non-blank paint. The non-blank paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric non_blank_paint(1217);
}

namespace dom {
  /**
   * generated from dom.blink_filesystem_used
   */
  enum class BlinkFilesystemUsedLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Webkit/Blink filesystem used
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram BLINK_FILESYSTEM_USED.
   */
  constexpr impl::Labeled<impl::CounterMetric, BlinkFilesystemUsedLabel> blink_filesystem_used(3764);

  /**
   * generated from dom.forget_skippable_during_idle
   * Percent of the cycle collector's forget skippable done during idle time
   * This metric was generated to correspond to the Legacy Telemetry linear histogram FORGET_SKIPPABLE_DURING_IDLE.
   */
  constexpr impl::CustomDistributionMetric forget_skippable_during_idle(3765);

  /**
   * generated from dom.forget_skippable_frequency
   * Number of forget skippables occurred during a minute
   * This metric was generated to correspond to the Legacy Telemetry linear histogram FORGET_SKIPPABLE_FREQUENCY.
   */
  constexpr impl::CustomDistributionMetric forget_skippable_frequency(3766);

  /**
   * generated from dom.fullscreen_transition_black
   * The time spent in the fully-black screen in fullscreen transition
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram FULLSCREEN_TRANSITION_BLACK_MS.
   */
  constexpr impl::TimingDistributionMetric fullscreen_transition_black(3767);

  /**
   * generated from dom.gc_in_progress
   * Time from the beginning of the first slice to the end of the last slice (ms)
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram GC_IN_PROGRESS_MS.
   */
  constexpr impl::TimingDistributionMetric gc_in_progress(3768);

  /**
   * generated from dom.gc_slice_during_idle
   * Percent of GC slice done during idle time
   * This metric was generated to correspond to the Legacy Telemetry linear histogram GC_SLICE_DURING_IDLE.
   */
  constexpr impl::CustomDistributionMetric gc_slice_during_idle(3769);

  /**
   * generated from dom.innerwindows_with_mutation_listeners
   */
  enum class InnerwindowsWithMutationListenersLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Deleted or to-be-reused innerwindow which has had mutation event listeners.
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram INNERWINDOWS_WITH_MUTATION_LISTENERS.
   */
  constexpr impl::Labeled<impl::CounterMetric, InnerwindowsWithMutationListenersLabel> innerwindows_with_mutation_listeners(3770);

  /**
   * generated from dom.script_loading_source
   */
  enum class ScriptLoadingSourceLabel: uint16_t {
    eInline = 0,
    eSourcefallback = 1,
    eSource = 2,
    eAltdata = 3,
    e__Other__,
  };
  /**
   * Record the input from which the bytes are coming from, for each script in a document.
   * This metric was generated to correspond to the Legacy Telemetry categorical histogram DOM_SCRIPT_LOADING_SOURCE.
   */
  constexpr impl::Labeled<impl::CounterMetric, ScriptLoadingSourceLabel> script_loading_source(3771);

  /**
   * generated from dom.slow_script_notice_count
   * Count slow script notices
   * This metric was generated to correspond to the Legacy Telemetry count histogram SLOW_SCRIPT_NOTICE_COUNT.
   */
  constexpr impl::CounterMetric slow_script_notice_count(3772);

  /**
   * generated from dom.slow_script_page_count
   * The number of pages that trigger slow script notices
   * This metric was generated to correspond to the Legacy Telemetry count histogram SLOW_SCRIPT_PAGE_COUNT.
   */
  constexpr impl::CounterMetric slow_script_page_count(3773);

  /**
   * generated from dom.storage_access_api_ui
   */
  enum class StorageAccessApiUiLabel: uint16_t {
    eRequest = 0,
    eAllowautomatically = 1,
    eDeny = 2,
    eAllow = 3,
    eAllowonanysite = 4,
    e__Other__,
  };
  /**
   * Storage Access API UI events.
   * This metric was generated to correspond to the Legacy Telemetry categorical histogram STORAGE_ACCESS_API_UI.
   */
  constexpr impl::Labeled<impl::CounterMetric, StorageAccessApiUiLabel> storage_access_api_ui(3774);

  /**
   * generated from dom.webkit_directory_used
   */
  enum class WebkitDirectoryUsedLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * HTMLInputElement.webkitdirectory attribute used
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram WEBKIT_DIRECTORY_USED.
   */
  constexpr impl::Labeled<impl::CounterMetric, WebkitDirectoryUsedLabel> webkit_directory_used(3775);

  /**
   * generated from dom.xmlhttprequest_async_or_sync
   */
  enum class XmlhttprequestAsyncOrSyncLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Type of XMLHttpRequest, async or sync
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram XMLHTTPREQUEST_ASYNC_OR_SYNC.
   */
  constexpr impl::Labeled<impl::CounterMetric, XmlhttprequestAsyncOrSyncLabel> xmlhttprequest_async_or_sync(3776);
}

namespace dom_contentprocess {
  /**
   * generated from dom.contentprocess.build_id_mismatch
   * The number of times the about:restartrequired page appeared due to a buildID mismatch between the parent and the content processes. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.buildID_mismatch.
   */
  constexpr impl::CounterMetric build_id_mismatch(3777);

  /**
   * generated from dom.contentprocess.build_id_mismatch_false_positive
   * The number of times a process crashed early but we could verify it was not because of buildID mismatch between the parent and the content processes. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.buildID_mismatch_false_positive.
   */
  constexpr impl::CounterMetric build_id_mismatch_false_positive(3778);

  /**
   * generated from dom.contentprocess.launch_is_sync
   */
  enum class LaunchIsSyncLabel: uint16_t {
    eFalse = 0,
    eTrue = 1,
    e__Other__,
  };
  /**
   * Whether a content process was launched synchronously (unnecessarily delaying UI response).
   * This metric was generated to correspond to the Legacy Telemetry boolean histogram CONTENT_PROCESS_LAUNCH_IS_SYNC.
   */
  constexpr impl::Labeled<impl::CounterMetric, LaunchIsSyncLabel> launch_is_sync(3779);

  /**
   * generated from dom.contentprocess.launch_mainthread
   * Time spent on the main thread during asynchronous content process launch.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CONTENT_PROCESS_LAUNCH_MAINTHREAD_MS.
   */
  constexpr impl::TimingDistributionMetric launch_mainthread(3780);

  /**
   * generated from dom.contentprocess.launch_total
   * Total time elapsed during asynchronous content process launch, until the process is usable for loading content.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CONTENT_PROCESS_LAUNCH_TOTAL_MS.
   */
  constexpr impl::TimingDistributionMetric launch_total(3781);

  /**
   * generated from dom.contentprocess.os_priority_change_considered
   * The number of times we've had the opportunity to change content process priority due to a tab switch or a tab being opened. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.os_priority_change_considered.
   */
  constexpr impl::CounterMetric os_priority_change_considered(3782);

  /**
   * generated from dom.contentprocess.os_priority_lowered
   * The number of times a content process has had its OS priority lowered due to only containing background tabs without audible media playing. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.os_priority_lowered.
   */
  constexpr impl::CounterMetric os_priority_lowered(3783);

  /**
   * generated from dom.contentprocess.os_priority_raised
   * The number of times a content process has had its OS priority raised due to containing at least one foregrounded tab, or a tab with audible media has started playing in it. This metric was generated to correspond to the Legacy Telemetry scalar dom.contentprocess.os_priority_raised.
   */
  constexpr impl::CounterMetric os_priority_raised(3784);

  /**
   * generated from dom.contentprocess.sync_launch
   * Time elapsed during synchronous content process launch until the process is usable for loading content.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram CONTENT_PROCESS_SYNC_LAUNCH_MS.
   */
  constexpr impl::TimingDistributionMetric sync_launch(3785);
}

namespace dom_parentprocess {
  /**
   * generated from dom.parentprocess.private_window_used
   * Whether a private browsing window has been used in the session. This metric was generated to correspond to the Legacy Telemetry scalar dom.parentprocess.private_window_used.
   */
  constexpr impl::BooleanMetric private_window_used(3786);

  /**
   * generated from dom.parentprocess.process_launch_errors
   * Collect precise set of error code and calling site upon process creation failure path. This metric was generated to correspond to the Legacy Telemetry scalar dom.parentprocess.process_launch_errors.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> process_launch_errors(3787);
}

namespace dom_textfragment {
  /**
   * generated from dom.textfragment.create_directive
   * Time spent in FragmentDirective::CreateTextDirective()
   */
  constexpr impl::TimingDistributionMetric create_directive(3788);

  /**
   * generated from dom.textfragment.find_directives
   * Time spent in TextDirectiveFinder::FindTextDirectivesInDocument() per page load
   */
  constexpr impl::TimingDistributionMetric find_directives(3789);
}

namespace perf {
  /**
   * generated from perf.dns_first_byte
   * The time from a top-level document's HTTP channel open to the first byte of the reply is received (ms). Keyed by TRR domain for DoH or 'Native' otherwise
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_PERF_FIRST_BYTE_MS.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> dns_first_byte(3790);

  /**
   * generated from perf.dns_first_contentful_paint
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. Keyed by TRR domain for DoH or 'Native' otherwise
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram DNS_PERF_FIRST_CONTENTFUL_PAINT_MS.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> dns_first_contentful_paint(3791);

  /**
   * generated from perf.h3p_first_contentful_paint
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses HTTP3. It is keyed based on whether a "priority" header has been received.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram H3P_PERF_FIRST_CONTENTFUL_PAINT_MS.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> h3p_first_contentful_paint(3792);

  /**
   * generated from perf.h3p_page_load_time
   * Time in milliseconds from navigationStart to loadEventStart for the foreground http or https root content document. This is collected only on page load where the main document uses HTTP3. It is keyed based on whether a "priority" header has been received.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram H3P_PERF_PAGE_LOAD_TIME_MS.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> h3p_page_load_time(3793);

  /**
   * generated from perf.http3_first_contentful_paint
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses or suppports HTTP3
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_PERF_FIRST_CONTENTFUL_PAINT_MS.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> http3_first_contentful_paint(3794);

  /**
   * generated from perf.http3_page_load_time
   * Time in milliseconds from navigationStart to loadEventStart for the foreground http or https root content document. This is collected only on page load where the main document uses or suppports HTTP3
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram HTTP3_PERF_PAGE_LOAD_TIME_MS.
   */
  constexpr impl::Labeled<impl::TimingDistributionMetric, DynamicLabel> http3_page_load_time(3795);

  /**
   * generated from perf.largest_contentful_paint
   * Time from navigation start to largest contentful paint.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint(3796);

  /**
   * generated from perf.largest_contentful_paint_from_response_start
   * Time from response start to largest contentful paint.
   */
  constexpr impl::TimingDistributionMetric largest_contentful_paint_from_response_start(3797);

  /**
   * generated from perf.page_load
   */
  struct PageLoadExtra {
    mozilla::Maybe<uint32_t> delazifyTime;
    mozilla::Maybe<uint32_t> dnsLookupTime;
    mozilla::Maybe<uint32_t> fcpTime;
    mozilla::Maybe<uint32_t> features;
    mozilla::Maybe<bool> hasSsd;
    mozilla::Maybe<uint32_t> httpVer;
    mozilla::Maybe<uint32_t> jsExecTime;
    mozilla::Maybe<uint32_t> lcpTime;
    mozilla::Maybe<uint32_t> loadTime;
    mozilla::Maybe<nsCString> loadType;
    mozilla::Maybe<uint32_t> redirectCount;
    mozilla::Maybe<uint32_t> redirectTime;
    mozilla::Maybe<uint32_t> responseTime;
    mozilla::Maybe<bool> sameOriginNav;
    mozilla::Maybe<uint32_t> timeToRequestStart;
    mozilla::Maybe<uint32_t> tlsHandshakeTime;
    mozilla::Maybe<nsCString> trrDomain;
    mozilla::Maybe<bool> usingWebdriver;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (delazifyTime) {
        extraKeys.AppendElement()->AssignASCII("delazify_time");
        extraValues.AppendElement()->AppendInt(delazifyTime.value());
      }
      if (dnsLookupTime) {
        extraKeys.AppendElement()->AssignASCII("dns_lookup_time");
        extraValues.AppendElement()->AppendInt(dnsLookupTime.value());
      }
      if (fcpTime) {
        extraKeys.AppendElement()->AssignASCII("fcp_time");
        extraValues.AppendElement()->AppendInt(fcpTime.value());
      }
      if (features) {
        extraKeys.AppendElement()->AssignASCII("features");
        extraValues.AppendElement()->AppendInt(features.value());
      }
      if (hasSsd) {
        extraKeys.AppendElement()->AssignASCII("has_ssd");
        extraValues.AppendElement()->AssignASCII(hasSsd.value() ? "true" : "false");
      }
      if (httpVer) {
        extraKeys.AppendElement()->AssignASCII("http_ver");
        extraValues.AppendElement()->AppendInt(httpVer.value());
      }
      if (jsExecTime) {
        extraKeys.AppendElement()->AssignASCII("js_exec_time");
        extraValues.AppendElement()->AppendInt(jsExecTime.value());
      }
      if (lcpTime) {
        extraKeys.AppendElement()->AssignASCII("lcp_time");
        extraValues.AppendElement()->AppendInt(lcpTime.value());
      }
      if (loadTime) {
        extraKeys.AppendElement()->AssignASCII("load_time");
        extraValues.AppendElement()->AppendInt(loadTime.value());
      }
      if (loadType) {
        extraKeys.AppendElement()->AssignASCII("load_type");
        extraValues.EmplaceBack(loadType.value());
      }
      if (redirectCount) {
        extraKeys.AppendElement()->AssignASCII("redirect_count");
        extraValues.AppendElement()->AppendInt(redirectCount.value());
      }
      if (redirectTime) {
        extraKeys.AppendElement()->AssignASCII("redirect_time");
        extraValues.AppendElement()->AppendInt(redirectTime.value());
      }
      if (responseTime) {
        extraKeys.AppendElement()->AssignASCII("response_time");
        extraValues.AppendElement()->AppendInt(responseTime.value());
      }
      if (sameOriginNav) {
        extraKeys.AppendElement()->AssignASCII("same_origin_nav");
        extraValues.AppendElement()->AssignASCII(sameOriginNav.value() ? "true" : "false");
      }
      if (timeToRequestStart) {
        extraKeys.AppendElement()->AssignASCII("time_to_request_start");
        extraValues.AppendElement()->AppendInt(timeToRequestStart.value());
      }
      if (tlsHandshakeTime) {
        extraKeys.AppendElement()->AssignASCII("tls_handshake_time");
        extraValues.AppendElement()->AppendInt(tlsHandshakeTime.value());
      }
      if (trrDomain) {
        extraKeys.AppendElement()->AssignASCII("trr_domain");
        extraValues.EmplaceBack(trrDomain.value());
      }
      if (usingWebdriver) {
        extraKeys.AppendElement()->AssignASCII("using_webdriver");
        extraValues.AppendElement()->AssignASCII(usingWebdriver.value() ? "true" : "false");
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * Recorded when a top level content document has been loaded.
   */
  constexpr impl::EventMetric<PageLoadExtra> page_load(3798);
}

namespace performance_pageload {
  /**
   * generated from performance.pageload.fcp
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric fcp(3799);

  /**
   * generated from performance.pageload.fcp_responsestart
   * The time between responseStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric fcp_responsestart(3800);

  /**
   * generated from performance.pageload.h3p_fcp_with_priority
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses HTTP3. A "priority" header has been received.
   */
  constexpr impl::TimingDistributionMetric h3p_fcp_with_priority(3801);

  /**
   * generated from performance.pageload.http3_fcp_http3
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses or suppports HTTP3.
   */
  constexpr impl::TimingDistributionMetric http3_fcp_http3(3802);

  /**
   * generated from performance.pageload.http3_fcp_supports_http3
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document supports but is not using HTTP3.
   */
  constexpr impl::TimingDistributionMetric http3_fcp_supports_http3(3803);

  /**
   * generated from performance.pageload.http3_fcp_without_priority
   * The time between navigationStart and the first contentful paint of a foreground http or https root content document, in milliseconds. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint. This is collected only on page load where the main document uses HTTP3. A "priority" header has not been received.
   */
  constexpr impl::TimingDistributionMetric http3_fcp_without_priority(3804);

  /**
   * generated from performance.pageload.load_time
   * Time in milliseconds from navigationStart to loadEventStart for the foreground http or https root content document. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric load_time(3805);

  /**
   * generated from performance.pageload.load_time_responsestart
   * Time in milliseconds from responseStart to loadEventStart for the foreground http or https root content document. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::TimingDistributionMetric load_time_responsestart(3806);
}

namespace performance_time {
  /**
   * generated from performance.time.dom_complete
   * Time from navigationStart to domComplete as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_complete(3807);

  /**
   * generated from performance.time.dom_content_loaded_end
   * Time from navigationStart to domContentLoadedEventEnd as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_content_loaded_end(3808);

  /**
   * generated from performance.time.dom_content_loaded_start
   * Time from navigationStart to domContentLoadedEventStart as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_content_loaded_start(3809);

  /**
   * generated from performance.time.dom_interactive
   * Time from navigationStart to domInteractive as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric dom_interactive(3810);

  /**
   * generated from performance.time.load_event_end
   * Time from navigationStart to loadEventEnd as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric load_event_end(3811);

  /**
   * generated from performance.time.load_event_start
   * Time from navigationStart to loadEventStart as per the W3C Performance Timing API. (Migrated from the geckoview metric of the same name.)
   */
  constexpr impl::TimingDistributionMetric load_event_start(3812);

  /**
   * generated from performance.time.to_dom_loading
   * Time in milliseconds from navigationStart to domLoading.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram TIME_TO_DOM_LOADING_MS.
   */
  constexpr impl::TimingDistributionMetric to_dom_loading(3813);

  /**
   * generated from performance.time.to_first_contentful_paint
   * The time between navigation start and the first contentful paint of a foreground root content document, in milliseconds. This only records documents that were in an active docshell throughout the whole time between navigation start and contentful paint. The contentful paint timestamp is taken during display list building and does not include rasterization or compositing of that paint.
   * This metric was generated to correspond to the Legacy Telemetry exponential histogram TIME_TO_FIRST_CONTENTFUL_PAINT_MS.
   */
  constexpr impl::TimingDistributionMetric to_first_contentful_paint(3814);
}

} // namespace mozilla::glean

#endif // mozilla_GleanDomMetrics_h
